Angular Popover Component

The Popover component for Angular represents a small overlay of content that is used to display secondary information of any element when it is clicked by a user.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxPopover [theme]="'fluent'" 
    [showCloseButton]="true" [selector]="'#button'" [title]="'Employees'"
    [arrowOffsetValue]="50" [offset]="{ left: left, top: top }">
    <div #employees></div>
</jqxPopover>

<div style="height: 33px; border-width: 1px; border-style: solid; padding: 10px;" class="jqx-widget-header">
    <jqxButton [theme]="'fluent'" #buttonReference 
        style="float: right" id="button" (onClick)="updatePopoverPosition()"
        [width]="150" [height]="35" [template]="'inverse'">
        View Employees
    </jqxButton>
</div>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, AfterViewInit, ViewEncapsulation, ElementRef } from '@angular/core';

import { jqxButtonComponent, jqxButtonModule } from 'jqwidgets-ng/jqxbuttons';

import { jqxPopoverModule, jqxPopoverComponent } from 'jqwidgets-ng/jqxpopover';
@Component({
    selector: 'app-root',
    imports: [jqxPopoverModule, jqxButtonModule],
    standalone: true,
    templateUrl: './app.component.html'
})

export class AppComponent implements AfterViewInit {
    @ViewChild('employees') employees: ElementRef;
    @ViewChild('buttonReference') myButton: jqxButtonComponent;

    top: number;
    left: number;

    ngAfterViewInit() {
        let data = new Array();
        let firstNames = ['Nancy', 'Andrew', 'Janet', 'Margaret', 'Steven', 'Michael', 'Robert', 'Laura', 'Anne'];
        let lastNames = ['Davolio', 'Fuller', 'Leverling', 'Peacock', 'Buchanan', 'Suyama', 'King', 'Callahan', 'Dodsworth'];
        let titles = ['Sales Representative', 'Vice President, Sales', 'Sales Representative', 'Sales Representative', 'Sales Manager', 'Sales Representative', 'Sales Representative', 'Inside Sales Coordinator', 'Sales Representative'];

        for (let i = 0; i < firstNames.length; i++) {
            let row = {};
            row['firstname'] = firstNames[i];
            row['lastname'] = lastNames[i];
            row['title'] = titles[i];
            let imgurl = 'https://www.jqwidgets.com/angular/images/' + firstNames[i].toLowerCase() + '.png';
            let img = '<img height="50" width="45" src="' + imgurl + '"/>';
            let table = '<table style="min-width: 150px;"><tr><td style="width: 55px;" rowspan="2">' + img + '</td><td>' + firstNames[i] + " " + lastNames[i] + '</td></tr><tr><td>' + titles[i] + '</td></tr></table>';
            this.employees.nativeElement.innerHTML += table;
        }
    }

    updatePopoverPosition() {
        this.left = this.myButton.host[0].offsetLeft + 16;
        this.top = this.myButton.host[0].offsetTop;
    }
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Popover API

API Reference of the jQWidgets Popover component for Angular: Popover API

Vue UI Components Documentation
Vue Popover Component
The Popover component for Vue represents a small overlay of content that is used to display secondary information of any element when it is clicked by a user.
Prerequisites
Refer to Vue Getting Started before you start with this help topic.
Configuration
After you have created your App.vue file, here is how you should structure it:
The Popover component for Vue requires the following import:
import JqxPopover from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxpopover.vue';
Add the jqxPopover component to the components section of the the Vue class:
components: { JqxPopover },
Template
The App.vue has a <template>
structural tag where we determine the application structure.
There we will also set the tags for the new components - <JqxPopover/>
<template> <JqxPopover :title="title" :selector="selector" :offset="offset"> <div ref="employees"></div> </JqxPopover> <JqxButton style="float: right; margin-top: 10px; padding: 8px 0px; border-radius: 6px;" class="my-button" :width="140" :height="35">View Employees </JqxButton></template>
Properties
The properties of the <JqxPopover/> component are defined in the data
member of the Vue class.
We should put them in the return object of the data function:
data: function () { return { selector: '.my-button', title: 'Employees', offset: { left: 0, top: -125 } }}
Events
The events in Vue are set as an attribute with @ prefix, for example:
All events that are bound to a component are implemented in the methods
member of the Vue class.
Methods
To use a component's method we should have its reference. In Vue we refer to a component by the special $refs
property.
Before that we need to add the desired name reference to that component:
<JqxPopover ref="popover"></JqxPopover>
Here how you can use a component's method:
this.$refs.popover.close();
If we want to add additional methods we should also implement them in the methods
member.
In case we need to do something after the components are rendered, we should use the mounted
member.
In this case:
If you have followed the above steps, you App.vue file would look like this:

React UI Components Documentation
ReactJS Popover Component
The Popover component for ReactJS represents a small overlay of content that is used to display secondary information of any element when it is clicked by a user.
Prerequisites
Refer to ReactJS Getting Started before you start with this help topic.
Configuration
The Popover component for ReactJS requires the following imports.
import React from 'react';import ReactDOM from 'react-dom'; import JqxPopover from 'jqwidgets-react/react_jqxpopover.js';
Then we create our component class. Properties and methods are put as ReactJS props.
class App extends React.Component { render () { return ( <JqxPopover width={220} height={40} showCloseButton={true} selector={'#button'} /> ) }}
Finally we render our class in the desired HTML element:
ReactDOM.render(<App />, document.getElementById('app'));
Events Methods & Properties
In order to bind to any event, change any property or call any method, we need a reference to the component.
For that we use the ReactJS "ref" Callback Attribute:
<JqxPopover ref='myPopover' width={220} height={40}..... />
Now, when we have a reference, we need to call the desired event/property/method.
This is done in the componentDidMount() ReactJS Component Lifecycle method.
class App extends React.Component { componentDidMount() { //your logic } render () { return ( .... ) }};
Events
The open event is triggered when the popover is opened.
The following example demonstrates how to add an event listener:
componentDidMount (){ this.refs.myPopover.on('open', (event) => { //your logic }); }
Methods & Properties
This is how you call methods & props:
//Open Methodthis.refs.myPopover.open(); //Close Methodthis.refs.myPopover.close(); //Get Propertieslet height = this.refs.myPopover.height(); //Set Propertiesthis.refs.myPopover.height(75);
Every component have a method setOptions which accepts a object as an argument. This object contains component settings.
this.refs.myPopover.setOptions({ showArrow: true, width: 200, height: 50})
Every component also have a method getOptions which returns a object containing the component settings.
Popover Examples
Overview
The following example demonstrates how to create a Popover component.